unit PPKNotaU; {Initialization & Unpacking routines for PGC format to PGN}

interface

uses WinDOS,Strings,TypeUnit,MiscUnit,PPKTypes;

{See PPKCall.pas for initialization and exit code via the dll. Source code for a 
sample application, calling the dll, is available in the MyBase.zip download.}

procedure FatalLogic(msg:Str31);
procedure CIO(tag:integer);
procedure InitTransforms;
function  LoadBinData:Boolean;
function  DestroyBinData:Boolean;
procedure UnPackNotation(PC2,PC:PChar);
procedure UnPackName(PC,PC2:PChar);
procedure UnPackWord(PC,PC2:PChar);
procedure UnPackDate(PC,PC2:PChar);
procedure UnPackRound(PC,PC2:PChar);
procedure UnPackECO(PC,PC2:PChar);
procedure UnPackELO(PC,PC2:PChar);
procedure UnPackResult(PC,PC2:PChar);
procedure UnPackPGNGame(Flags:integer;PC,PC2:PChar);
function  ValidateGame(PC:PChar):Boolean;
procedure RetrieveField(FID:integer;PC,PC2:PChar); 


implementation


procedure FatalLogic(msg:Str31);
begin
   with RI^ do
   begin
      LogicErr:=msg;
      Abort666:=666;
   end;
end;

procedure CIO(tag:integer);
var
   IOR      : integer;
   msg      : Str31;
   ioer     : Str31;
begin
   IOR:=IOResult;
   if IOR=0 then EXIT;
   Str(IOR,ioer);
   msg:=ValToStr(tag,3);
   msg:='IOErr '+ioer+' L'+msg;
   FatalLogic(msg);
end;

procedure InitTransforms;
var
   N,N2     : integer;
   aChr     : char;

   procedure Misc;
   begin
      inc(N2);
      while chr(N2) in RestrictSet do
         inc(N2);
      if N2>$3f then
         begin
            FatalLogic('Trap 4427');
            EXIT;
         end;
      RI^.TxfToLBA[ord(aChr)]:=chr(N2);
   end;

begin
   with RI^ do
   begin
   if MA=nil then FatalLogic('Trap 6836'); {LoadBinFl must be called first}
   if Abort666<>0 then EXIT;

   {The position: 1 2-8   9   10   11   ...150 <--looking at this NX gives...}
   {The value:    1 2-8  11+  12   14+  ...250 <--this}

   N:=1;N2:=1;

   FillChar(TxfTo150,sizeOf(TxfTo150),#0);
   TxfTo150[0]:=#255;

   while (N<=255) and (N2<=255) do
      begin
         while (N2<256) and (not (chr(N2) in T150Set)) do inc(N2);
         if N2<=255 then
            TxfTo150[N]:=chr(N2);
         inc(N);
         inc(N2);
      end;

   {1 2-8 9 10 11 12 13 14     ...250 251-255}
   {1 2-8 0  0  9 10  0 11     ...150   0-  0}

   FillChar(TxfFm150,sizeOf(TxfFm150),#0);
   TxfFm150[0]:=#255;

   N2:=0;
   for N:=1 to 255 do
      if chr(N) in T150Set then
         begin
            inc(N2);
            TxfFm150[N]:=chr(N2);
         end
      else
         TxfFm150[N]:=#0;

   N:=1;N2:=1;

   FillChar(TxfTo246,sizeOf(TxfTo246),#0);
   TxfTo246[0]:=#255;

   while (N<=255) and (N2<=255) do
      begin
         while (N2<256) and (not (chr(N2) in T246Set)) do inc(N2);
         if N2<=255 then
            TxfTo246[N]:=chr(N2);
         inc(N);
         inc(N2);
      end;

   FillChar(TxfFm246,sizeOf(TxfFm246),#0);
   TxfFm246[0]:=#255;

   N2:=0;
   for N:=1 to 255 do
      if chr(N) in T246Set then
         begin
            inc(N2);
            TxfFm246[N]:=chr(N2);
         end
      else
         TxfFm246[N]:=#0;

   for N:=1 to MoveMax do
      with MA^[N] do
      begin
         case cTbl of
            0: T0MLoc[cOrd]:=N;
            1: T1MLoc[cOrd]:=N;
            2: T2MLoc[cOrd]:=N;
            3: T3MLoc[cOrd]:=N;
            4: T4MLoc[cOrd]:=N;
         end;
      end;

   for N:=1 to SfxMax do {only 146}
      with SA^[N] do
         T0SLoc[cOrd]:=N;

   for N:=1 to NameMax do {NameMax & MoveMax are the same, 1114}
      with NA^[N] do
      begin
         case cTbl of
            0: T0NLoc[cOrd]:=N;
            1: T1NLoc[cOrd]:=N;
            2: T2NLoc[cOrd]:=N;
            3: T3NLoc[cOrd]:=N;
         end;
      end;
   for N:=1 to NameMax do {NameMax & MoveMax are the same, 1114}
      with NF^[N] do
      begin
         case cTbl of
            0: T0NFLoc[cOrd]:=N;
            1: T1NFLoc[cOrd]:=N;
            2: T2NFLoc[cOrd]:=N;
            3: T3NFLoc[cOrd]:=N;
         end;
      end;

   for N:=1 to WordMax do 
      with WA^[N] do
      begin
         case cTbl of
            0: T0WALoc[cOrd]:=N;
            1: T1WALoc[cOrd]:=N;
            2: T2WALoc[cOrd]:=N;
            3: T3WALoc[cOrd]:=N;
         end;
      end;

   for N:=1 to WordMax do 
      with WO^[N] do
      begin
         case cTbl of
            0: T0WOLoc[cOrd]:=N;
            1: T1WOLoc[cOrd]:=N;
            2: T2WOLoc[cOrd]:=N;
            3: T3WOLoc[cOrd]:=N;
         end;
      end;

   {--------From common alpha to 6 bit and back--------}
   FillChar(TxfToLBA,sizeOf(TxfToLBA),#0);
   TxfToLBA[0]:=#255;
   FillChar(TxfFmLBA,sizeOf(TxfFmLBA),#0);
   TxfFmLBA[0]:=#255;

   N2:=0;
   for aChr:='z' downto 'a' do {the particular ordering used is heuristic, fewer synonyms}
      Misc;
   for aChr:='Z' downto 'A' do
      Misc;
   aChr:=' ';
   Misc;
   for aChr:=',' to '.' do {includes hyphen}
      Misc;
   for aChr:='''' to ')' do {includes ) }
      Misc;
   if Abort666<>0 then EXIT;

   for aChr:=' ' to 'z' do
      if TxfToLBA[ord(aChr)]<>#0 then
         TxfFMLBA[ord(TxfToLBA[ord(aChr)])]:=aChr;
   {--------End common alpha---------------------------}
   end; {with RI^ do}
end;

function LoadBinData:Boolean;
var
   N           : integer;
   aByte       : byte;
   aStr        : Str255;
   FlIn        : file;
   sPtr        : CharsPtr;

   function ReadStuff:Boolean;
   begin
      ReadStuff:=false;
      with RI^ do
      begin
      BlockRead(Flin,aByte,1);CIO(767);if Abort666<>0 then EXIT;
      if aByte=0 then
         begin
            FatalLogic('Trap 5639');
            EXIT;
         end;
      aStr[0]:=chr(aByte);
      BlockRead(FlIn,sPtr^,aByte);CIO(768);if Abort666<>0 then EXIT;
      end;
      ReadStuff:=True;
   end;
begin
   LoadBinData:=false;
   sPtr:=@aStr[1];
   with RI^ do
   begin
      GetMem(NA1,sizeOf(NotaAry)); {remember to destroy all allocated memory}
      GetMem(NA2,sizeOf(NotaAry));
      GetMem(MA,sizeOf(MoveAry));
      GetMem(SA,sizeOf(SfxAry));
      GetMem(NA,sizeOf(NameAry));
      GetMem(NF,sizeOf(NameAry));
      GetMem(WA,sizeOf(WordAry));
      GetMem(WO,sizeOf(WordAry));

      Assign(FlIn,BinFN);
      Reset(FlIn,1);CIO(765);if Abort666<>0 then EXIT;
      if FileSize(FlIn)<>BinFS then
         begin
            FatalLogic('Trap 5637');
            EXIT;
         end;
      BlockRead(Flin,aByte,1);CIO(766);if Abort666<>0 then EXIT;
      if aByte<>$ff then
         begin
            FatalLogic('Trap 5638');
            EXIT;
         end;
      for N:=1 to NotaMax do
         begin
            if ReadStuff then {these don't need Abort chk since they exit false}
               NA1^[N]:=NewPasPStr(aStr)
            else
               EXIT;
         end;
      for N:=1 to NotaMax do
         begin
            if ReadStuff then
               NA2^[N]:=NewPasPStr(aStr)
            else
               EXIT;
         end;
      BlockRead(FlIn,MA^,sizeOf(MoveAry));CIO(767);if Abort666<>0 then EXIT;
      BlockRead(FlIn,SA^,sizeOf( SfxAry));CIO(778);if Abort666<>0 then EXIT;
      BlockRead(FlIn,NA^,sizeOf(NameAry));CIO(768);if Abort666<>0 then EXIT;
      BlockRead(FlIn,NF^,sizeOf(NameAry));CIO(770);if Abort666<>0 then EXIT;
      BlockRead(FlIn,WA^,sizeOf(WordAry));CIO(771);if Abort666<>0 then EXIT;
      BlockRead(FlIn,WO^,sizeOf(WordAry));CIO(772);if Abort666<>0 then EXIT;
      BlockRead(FlIn,gfiller,sizeOf(cfiller));CIO(773);if Abort666<>0 then EXIT;
      BlockRead(FlIn,aByte,1);CIO(769);if Abort666<>0 then EXIT;
      if aByte<>$ff then
         begin
            FatalLogic('Trap 5641');
            EXIT;
         end;
      Close(FlIn);CIO(781);if Abort666<>0 then EXIT;

      GetMem(ECOStr,ECOSLen+1);
      StrCopy(ECOStr,ECOS1);
      StrCat(ECOStr,ECOS2);
      StrCat(ECOStr,ECOS3);
      if not (StrLen(ECOStr)=(ECOSLen)) then
         begin
            FatalLogic('Trap 5640');
            EXIT;
         end;
   end;
   LoadBinData:=True;
end;

function DestroyBinData:Boolean;
var
   N           : integer;
begin
   DestroyBinData:=false;
   with RI^ do
   begin
      for N:=1 to NotaMax do
         begin
            StrDispose(NA1^[N]);
            StrDispose(NA2^[N]);
            NA1^[N]:=nil;
            NA2^[N]:=nil;
         end;
      FreeMem(NA1,sizeOf(NotaAry));
      FreeMem(NA2,sizeOf(NotaAry));
      FreeMem(MA,sizeOf(MoveAry));
      FreeMem(SA,sizeOf(SfxAry));
      FreeMem(NA,sizeOf(NameAry));
      FreeMem(NF,sizeOf(NameAry));
      FreeMem(WA,sizeOf(WordAry));
      FreeMem(WO,sizeOf(WordAry));
      NA1:=nil;
      NA2:=nil;
      MA:=nil;
      SA:=nil;
      NA:=nil;
      NF:=nil;
      WA:=nil;
      WO:=nil;

      if work1PC<>nil then
         StrDispose(work1PC);
      if work2PC<>nil then
         StrDispose(work2PC);
      if work3PC<>nil then
         StrDispose(work3PC);
      if work4PC<>nil then
         StrDispose(work4PC);
      work1PC:=nil;
      work2PC:=nil;
      work3PC:=nil;
      work4PC:=nil;

      FreeMem(ECOStr,ECOSLen+1);
      ECOStr:=nil;
   end;
   DestroyBinData:=True;
end;

procedure RunOut(var S1:Str255;var D2:PChar);
var
   N        : integer;
begin
   for N:=1 to length(S1) do
      begin
         D2[0]:=S1[N];
         inc(D2);
      end;
   D2[0]:=#0; {dont inc}
end;

procedure RunOutP(DB:PChar;var D2:PChar);
begin
   while DB[0]<>#0 do
      begin
         D2[0]:=DB[0];
         inc(D2);inc(DB);
      end;
   D2[0]:=#0;
end;

procedure SfxUnPack(PC,PC2:PChar;var ToNxtS,ToNxtD:integer);
var
   N        : integer;
   locStr   : Str255;
   D        : PChar;
   aChr     : char;
begin
   with RI^ do
   begin
      if (PC=nil) or (PC[0]=#0) then FatalLogic('Trap 2379');
      if not (PC[0] in T146PASet) then FatalLogic('Trap 2380'); {T146+ASCII}
      if Abort666<>0 then EXIT;
      ToNxtS:=0;
      locStr:='';
      N:=0;
      repeat
         D:=PC+N;
         aChr:=D[0];
         if aChr in ASCIISet then
            ASMCatC(locStr,aChr)
         else
            ASMCat(locStr,SA^[T0SLoc[ord(aChr)]].cSfx);
         inc(N);
      until not (PC[N] in T146PASet);

      if aChr<>#0 then
         ToNxtS:=N;
      StrPCopy(PC2,locStr);
      ToNxtD:=length(locStr);
   end;
end;

procedure AlphaUnpack(PC,PC2:PChar);
var
   LL          : longint;
   D2          : PChar;
   N,N2        : integer;
   N2S         : integer;
   Lo,Hi       : integer;
   MinTimes    : integer;
   SLen        : word;
   FullCt      : word;
   PartCt      : word;
   aByte       : byte;

begin
   with RI^ do
   begin
   SLen:=StrLen(PC);
   FullCt:=SLen div 3;
   PartCt:=SLen mod 3;

   if PartCt=0 then
      MinTimes:=FullCt-1
   else
      MinTimes:=FullCt;

   N2S:=2;

   for N:=0 to MinTimes do
      begin
         LL:=0;
         if (N=MinTimes) and (PartCt>0) then
            N2S:=PartCt-1;
         for N2:=N2S downto 0 do
            begin
               D2:=PC+N*3+N2;        {use of D2 eliminates subscripting}
               LL:=LL or ord(D2[0]);
               if N2>0 then
                  LL:=LL shl 8;
            end;

         Hi:=((N+1)*4)-1;
         Lo:= Hi-3;

         for N2:=Hi downto Lo do
            begin
               aByte:=ord(TxfFmLBA[byte(LL) and $3f]);
               if aByte=255 then
                  Break;
               D2:=PC2+N2;
               D2[0]:=chr(aByte);
               LL:=LL shr 6;
            end;
      end;

      D2:=PC2+Hi+1;
      D2[0]:=#0;
      if aByte=255 then
         StrCopy(PC2+Lo,PC2+N2+1);

   end; {with RI^ do}
end;

function VersionMarkChk(VM:char):Boolean;
var
   Version        : byte; {logic error & false if ver mismatch; false if deleted}
   MarkDel        : byte;
begin
   VersionMarkChk:=false;
   VM:=RI^.TxfFm246[ord(VM)];
   Version:=ord(VM) shr 2;
   if Version<>cVersion then
      begin
         FatalLogic('Trap U643');
         EXIT;
      end;
   MarkDel:=ord(VM) and $03;              
   if MarkDel in [cDeleted,cMarkDel] then
      EXIT;
   VersionMarkChk:=True;
end;

function MarkDelMaint(Flag:integer;var VM:char;var Mark,Del:Boolean):integer; {function only for Ver return}
var
   cmd      : integer;
   Version  : byte;
   MarkDel  : byte;
   locVM    : char;
begin
   locVM:=RI^.TxfFm246[ord(VM)]; {must always be passed the actual VMD char}
   Version:=ord(locVM) shr 2;
   cmd:=Flag and $00c0;
   case cmd of
      MRK_ReturnVer,
      MRK_ReturnMrkDel:
         begin
            MarkDel:=ord(locVM) and $03; {5/98 was VM, not locVM}
            if MarkDel in [cMarked,cMarkDel] then
               Mark:=True
            else
               Mark:=false;
            if MarkDel in [cDeleted,cMarkDel] then
               Del:=True
            else
               Del:=false;
            if (cmd=MRK_ReturnMrkDel) and
               (Version<>cVersion) then
               begin
                  MarkDelMaint:=Version;
                  FatalLogic('Trap U644');
                  EXIT;
               end;
         end;
      MRK_SetMrkDel:
         begin
            if Mark then
               if Del then
                  MarkDel:=cMarkDel
               else
                  MarkDel:=cMarked
            else
               if Del then
                  MarkDel:=cDeleted
               else
                  MarkDel:=0;
            locVM:=chr(ord(locVM) and $fc or MarkDel); {5/98 v1 to v2 bug; was ord(VM)}
            VM:=RI^.TxfTo246[ord(locVM)];
         end;
      MRK_Reset: {for when things go wrong}
         begin
            Version:=cVersion;
            locVM:=chr(Version shl 2); {eg, markdel is 0}
            VM:=RI^.TxfTo246[ord(locVM)];
         end
      else
         begin
            FatalLogic('Trap 5723');
            EXIT;
         end;
   end; {case}
   MarkDelMaint:=Version;
end;

procedure UnPackNotation(PC2,PC:PChar);
var
   TblItem     : integer;
   NLen        : integer;
   D1,D2       : PChar;
begin
   with RI^ do
   begin
   if PC2[0]<>fd253 then
      begin
         FatalLogic('Trap 4329');
         EXIT;
      end;
   if PC2[1]=TAB then
      begin
         StrCopy(PC,PC2+2); {game had hi-ascii; wasnt packed}
         EXIT;
      end;
   if PC2[1]=fc252 then {has packed opening str}
      begin
         NLen:=ord(PC2[2]);
         if NLen<128 then
            begin
               TblItem:=ord(RI^.TxfFm150[ord(PC2[3])]);
               StrCopy(PC,NA1^[TblItem]);
               if chr(NLen) in [Succ(CAR),Succ(LNF),Succ(#26)] then {4/98 was "Pred"}
                  if PC[NLen-1]=' ' then
                     NLen:=NLen-1; {forbidden lengths were bumped up, bring back down}
            end
         else
            begin
               NLen:=NLen and $007f;
               TblItem:=ord(RI^.TxfFm150[ord(PC2[3])]);
               StrCopy(PC,NA2^[TblItem]);
            end;
         D1:=PC+NLen;
         D1[0]:=' '; inc(D1);
         D2:=PC2+4;
      end
   else
      begin
         D1:=PC;
         D2:=PC2+1;
      end;
   while D2[0]<>#0 do
      begin
         case D2[0] of
            #01:
               begin
                  StrPCopy(D1,MA^[RI^.T1MLoc[ord(D2[1])]].cMove);
                  D1:=D1+StrLen(D1);
                  D2:=D2+2;
                  if not (D2[0] in ['+','!','?','#',#0]) then
                     begin
                        D1[0]:=' ';
                        inc(D1);
                     end;
               end;
            #02:
               begin
                  StrPCopy(D1,MA^[RI^.T2MLoc[ord(D2[1])]].cMove);
                  D1:=D1+StrLen(D1);
                  D2:=D2+2;
                  if not (D2[0] in ['+','!','?','#',#0]) then
                     begin
                        D1[0]:=' ';
                        inc(D1);
                     end;
               end;
            #03:
               begin
                  StrPCopy(D1,MA^[RI^.T3MLoc[ord(D2[1])]].cMove);
                  D1:=D1+StrLen(D1);
                  D2:=D2+2;
                  if not (D2[0] in ['+','!','?','#',#0]) then
                     begin
                        D1[0]:=' ';
                        inc(D1);
                     end;
               end;
            #04:
               begin
                  StrPCopy(D1,MA^[RI^.T4MLoc[ord(D2[1])]].cMove);
                  D1:=D1+StrLen(D1);
                  D2:=D2+2;
                  if not (D2[0] in ['+','!','?','#',#0]) then
                     begin
                        D1[0]:=' ';
                        inc(D1);
                     end;
               end;
            else
               begin
                  if D2[0] in T150Set then
                     begin
                        StrPCopy(D1,MA^[RI^.T0MLoc[ord(D2[0])]].cMove);
                        D1:=D1+StrLen(D1);
                        inc(D2);
                        if not (D2[0] in ['+','!','?','#',#0]) then
                           begin
                              D1[0]:=' ';
                              inc(D1);
                           end;
                     end
                  else
                     begin
                        while D2[0] in ASCIISet do {handles the entire run}
                           begin
                              D1[0]:=D2[0];
                              inc(D1);
                              if (D2[0] in ['+','!','?','#']) and
                                 (not (D2[1] in [' ','!','?'])) and
                                 (D2[1] in ASCIISet) then
                                 begin
                                    D1[0]:=' ';
                                    inc(D1);
                                 end;
                              inc(D2);
                           end;
                        if D2[0]<>#0 then
                           begin
                              D1[0]:=' ';
                              inc(D1);
                           end;
                     end;
               end;
         end; {case}
      end;

   D1[0]:=#0;
   end; {with RI^ do}
end; {UnPackNotation}
  
procedure UnPackName(PC,PC2:PChar);
var
   N           : integer;
   NDX         : integer;
   ToNxtS      : integer;
   ToNxtD      : integer;
   W           : word;
   SLen        : word;
   D1,D2       : PChar;
   TLen        : byte;
   Tbl         : byte;
   Map         : byte;
   tOrd        : byte;
   CC          : byte;
   aByte       : byte;

   procedure SimpleNAOrd(D1X,D2X:PChar;var ToNxtD:integer);
   begin
      with RI^ do
      begin
         NDX:=T0NLoc[ord(D1X[0])];
         if (NDX<1) or (NDX>NameMax) then
            begin
               FatalLogic('Trap 9354');
               EXIT;
            end;
         with NA^[NDX] do
         begin
            StrPCopy(D2X,cName);
            ToNxtD:=length(cName);
         end;
      end;
   end;

   procedure SimpleNFOrd(D1X,D2X:PChar;var ToNxtD:integer);
   begin
      with RI^ do
      begin
         NDX:=T0NFLoc[ord(D1X[0])];
         if (NDX<1) or (NDX>NameMax) then
            begin
               FatalLogic('Trap 9355');
               EXIT;
            end;
         with NF^[NDX] do
         begin
            StrPCopy(D2X,cName);
            ToNxtD:=length(cName);
         end;
      end;
   end;

   procedure NAOrdTLCombo(D1X,D2X:PChar;var ToNdxD:integer);
   begin
      with RI^ do
      begin
         aByte:=ord(D1X[1]);
         TLen:=aByte and $1f;
         Tbl:=aByte shr 6;
         case Tbl of
            0: NDX:=T0NLoc[ord(D1X[0])];
            1: NDX:=T1NLoc[ord(D1X[0])];
            2: NDX:=T2NLoc[ord(D1X[0])];
            3: NDX:=T3NLoc[ord(D1X[0])];
         end; {case}
         if (NDX<1) or (NDX>NameMax) then
            begin
               FatalLogic('Trap 8678');
               EXIT;
            end;
         StrPCopy(D2X,copy(NA^[NDX].cName,1,TLen));
         ToNxtD:=TLen;
      end;
   end;

   procedure NFOrdTLCombo(D1X,D2X:PChar;var ToNdxD:integer);
   begin
      with RI^ do
      begin
         aByte:=ord(D1X[1]);
         TLen:=aByte and $1f;
         Tbl:=aByte shr 6;
         case Tbl of
            0: NDX:=T0NFLoc[ord(D1X[0])];
            1: NDX:=T1NFLoc[ord(D1X[0])];
            2: NDX:=T2NFLoc[ord(D1X[0])];
            3: NDX:=T3NFLoc[ord(D1X[0])];
         end; {case}
         if (NDX<1) or (NDX>NameMax) then
            begin
               FatalLogic('Trap 8679');
               EXIT;
            end;
         StrPCopy(D2X,copy(NF^[NDX].cName,1,TLen));
         ToNxtD:=TLen;
      end;
   end;

   procedure ProcessFullNameOrd(var D2:PChar);
   begin
      with RI^ do
      begin
         case Tbl of
            0: NDX:=T0NLoc[tOrd];
            1: NDX:=T1NLoc[tOrd];
            2: NDX:=T2NLoc[tOrd];
            3: NDX:=T3NLoc[tOrd];
         end; {case}

         if (NDX<1) or (NDX>NameMax) then
            begin
               FatalLogic('Trap 8680');
               EXIT;
            end;

         if TLen=0 then
            if Tbl=0 then
               TLen:=length(NA^[NDX].cName)
            else
               begin
                  FatalLogic('Trap 7103');
                  EXIT;
               end;

         StrPCopy(D2,copy(NA^[NDX].cName,1,TLen));
         D2:=D2+TLen;
         D2[0]:=#0;
      end;
   end;

  procedure DisplacementProcessing;
   begin
      while D1[0]<>#0 do
         begin
            if D1[0] in T146PASet then
               begin
                  SfxUnpack(D1,D2,ToNxtS,ToNxtD);
                  if RI^.Abort666<>0 then EXIT;
                  inc(D1,ToNxtS);
                  inc(D2,ToNxtD);
               end;
            if D1[0]=#1 then
               begin
                  inc(D1);
                  SimpleNFOrd(D1,D2,ToNxtD);
                  if RI^.Abort666<>0 then EXIT;
                  inc(D1);
                  inc(D2,ToNxtD);
                  if D1[0] in T146Set then {the optimizer; 2 in a row allowed}
                     begin
                        SimpleNFOrd(D1,D2,ToNxtD);
                        if RI^.Abort666<>0 then EXIT;
                        inc(D1);
                        inc(D2,ToNxtD);
                     end;
               end;
            if D1[0]=#2 then
               begin
                  inc(D1);
                  NFOrdTLCombo(D1,D2,ToNxtD);
                  if RI^.Abort666<>0 then EXIT;
                  inc(D1,2);
                  inc(D2,ToNxtD);
               end;
            if (not (D1[0] in [#0..#2])) and
               (not (D1[0] in T146PASet)) then
               begin
                  FatalLogic('Trap 3286');
                  EXIT;
               end;
         end; {while}
      D2[0]:=#0;
   end;

   procedure MapDoctoring;
   var
      N           : integer;
      NDX         : integer; {for CC only}
      DY          : PChar;
      locStr      : Str31;
      CCR         : PChar;    {CCResult}
      CCRBuf      : array [0..7] of char;
      aByte       : byte;

      procedure ScanSeparate(DX:PChar); {Separate words}
      begin
         if RI^.Abort666<>0 then EXIT;
         while DX[0]<>#0 do
            begin
               DY:=DX-1;
               if (DX[0] in UpCaseSet) and not
                  (DY[0] in [' ','-','''']) then {leave the spc in!}
                  with RI^ do
                  begin
                     StrCopy(work1PC,DX);
                     DX[0]:=' ';
                     DX[1]:=#0;
                     StrCat(DX+1,work1PC);
                     inc(DX);
                  end;
               inc(DX);
            end;
      end;
      procedure JRPush(DX:PChar);
      var
         Len   : word;
      begin
         Len:=StrLen(DX);
         if Len<3 then FatalLogic('Trap 8923');
         if RI^.Abort666<>0 then EXIT;
         DX:=DX+Len-3;
         if DX[0]=' ' then EXIT;
         inc(DX);
         DX[3]:=#0;
         DX[2]:=DX[1];
         DX[1]:=DX[0];
         DX[0]:=' ';
      end;

      procedure CommaOver(DX:PChar;spcCt:integer); {Place comma in specif space}
      var
         lCt      : integer;
      begin
         if RI^.Abort666<>0 then EXIT;
         lCt:=0;
         while DX[0]<>#0 do
            begin
               if DX[0]=' ' then
                  begin
                     inc(lCt);
                     if lCt=spcCt then
                        begin
                           DX[0]:=',';
                           EXIT; 
                        end;
                  end;
               inc(DX);
            end;
      end;

      procedure CommaInsert(DX:PChar;spcCt:integer); {Place comma in specif space}
      var
         lCt      : integer;
      begin
         with RI^ do
         begin
            if Abort666<>0 then EXIT;
            lCt:=0;
            while DX[0]<>#0 do
               begin
                  if DX[0]=' ' then
                     begin
                        inc(lCt);
                        if lCt=spcCt then
                           begin
                              StrCopy(work1PC,DX);
                              StrCopy(DX+1,work1PC);
                              DX[0]:=',';
                              EXIT; 
                           end;
                     end;
                  inc(DX);
               end;
         end;
      end;

   begin
      with RI^ do
      if work1PC=nil then
         GetMem(work1PC,PCharStrLen);

      aByte:=map and $78;

      case aByte of
         $00: begin
                 ScanSeparate(PC2+1);
              end;
         $20: begin
                 ScanSeparate(PC2+1);
                 CommaOver(PC2+1,1);
              end;
         $40: begin
                 ScanSeparate(PC2+1);
                 CommaInsert(PC2+1,1);
              end;
         $60: begin
              end;
         $10: begin
              end;
         $30: begin
                 ScanSeparate(PC2+1);
                 CommaOver(PC2+1,3);
              end;
         $50: begin
                 ScanSeparate(PC2+1);
                 CommaInsert(PC2+1,3);
              end;
         $70: begin
              end;
         $08: begin
                 ScanSeparate(PC2+1);
              end;
         $28: begin
                 ScanSeparate(PC2+1);
                 CommaOver(PC2+1,1);
              end;
         $48: begin
                 ScanSeparate(PC2+1);
                 CommaInsert(PC2+1,1);
              end;
         $68: begin
                 JRPush(PC2);
              end;
         $18: begin
                 JRPush(PC2);
                 CommaOver(PC2+1,1);
              end;
         $38: begin
                 ScanSeparate(PC2+1);
                 CommaOver(PC2+1,2);
              end;
         $58: begin
                 ScanSeparate(PC2+1);
                 CommaInsert(PC2+1,2);
              end;
         $78: begin
                 JRPush(PC2);
                 CommaInsert(PC2+1,1);
              end;
      end; {case}
      if RI^.Abort666<>0 then EXIT;
      if CC=0 then
         EXIT;
      CCR:=CCRBuf;
      NDX:=CC and $3f;
      NDX:=NDX*4;
      if NDX>StrLen(CCPStr) then
         begin
            FatalLogic('Trap 6123'); {past the end of the str}
            EXIT;
         end;
      locStr:=StrSeg(CCPStr,NDX,NDX+2);
      if (CC and $40)>0 then
         locStr:=' ('+locStr+')'
      else
         locStr:=' '+locStr;
      StrPCopy(CCR,locStr);
      StrCat(PC2,CCR);
   end;

begin {UnPackName}
   with RI^ do
   begin
      PC2[0]:=#0;
      if PC=nil then
         begin
            FatalLogic('Trap 7897');
            EXIT;
         end;
      SLen:=StrLen(PC);
      if (SLen<2) or (SLen>500) or (PC[0]<>fe254) then
         begin
            FatalLogic('Trap 7898');
            EXIT;
         end;

      case SLen of
         2: begin
               SimpleNAOrd(PC+1,PC2,ToNxtD);
               EXIT;
            end;
         3: begin
               if PC[1]=TAB then
                  begin
                     StrCopy(PC2,PC+2);
                     EXIT;
                  end
               else
                  if PC[1]=fc252 then
                     begin
                        AlphaUnPack(PC+2,PC2);
                        EXIT;
                     end
                  else
                     begin
                        NAOrdTLCombo(PC+1,PC2,ToNxtD);
                        EXIT;
                     end;
            end;
      end; {case}
      if PC[1]=fc252 then {no map in these yet}
         begin
            AlphaUnPack(PC+2,PC2);
            EXIT;
         end
      else
         if PC[1]=TAB then
            begin
               StrCopy(PC2,PC+2);
               EXIT;
            end
         else
            if PC[1]=chr(04) then
               begin
                  SfxUnPack(PC+2,PC2,ToNxtS,ToNxtD);
                  EXIT;
               end;
      {----These now should all have Maps---------------------}
      if (ord(PC[1]) and $02)>0 then
         begin
            CC:=ord(PC[SLen-1]) and $7f;
            PC[SLen-1]:=#0;
            PC[1]:=chr(ord(PC[1]) and $fd);
            if PC[1]=#0 then PC[1]:=chr($80); {some combos would terminate string!}
            dec(SLen);
            if SLen=3 then
               begin
                  SLen:=4;
                  PC[4]:=#0;
                  PC[3]:=nilTL;
               end;
         end
      else
         CC:=0;

      D1:=PC;
      D2:=PC2;
      Map:=ord(D1[1]);
      tOrd:=ord(D1[2]);
      inc(D1,3);
      if D1[0]=nilTL then
         begin
            Tbl:=0;
            TLen:=0;
         end
      else
         begin
            aByte:=ord(D1[0]);
            TLen:=aByte and $1f;
            Tbl:=aByte shr 6;
         end;
      ProcessFullNameOrd(D2); {leftmost ord (Last or full names) }
      if Abort666<>0 then EXIT;
      inc(D1);
      DisplacementProcessing; {following ords (first/middle names) }
      if Abort666<>0 then EXIT;
      MapDoctoring;
   end; {with RI^ do}
end; {UnPackName}

procedure UnPackWord(PC,PC2:PChar);
var
   N,N2           : integer;
   NDX            : integer;
   SLen           : word;
   D1             : PChar;
   D2             : PChar;
   DB,DW          : PChar;
   locStr         : Str255;

   procedure PlaceFirstOrd(Tbl:byte;DB:PChar;var D2:PChar);
   var
      N           : integer;
   begin
      with RI^ do
      begin
         if PW=WO then
            inc(Tbl,4);
         case Tbl of
            0: NDX:=ord(T0WALoc[ord(DB[0])]);
            1: NDX:=ord(T1WALoc[ord(DB[0])]);
            2: NDX:=ord(T2WALoc[ord(DB[0])]);
            3: NDX:=ord(T3WALoc[ord(DB[0])]);

            4: NDX:=ord(T0WOLoc[ord(DB[0])]);
            5: NDX:=ord(T1WOLoc[ord(DB[0])]);
            6: NDX:=ord(T2WOLoc[ord(DB[0])]);
            7: NDX:=ord(T3WOLoc[ord(DB[0])]);
         end; {case}
         if (NDX<1) or (NDX>WordMax) then
            begin
               FatalLogic('Trap 6893');
               EXIT;
            end;
         with PW^[NDX] do
         begin
            DB:=@cWrd;
            inc(DB);
            for N:=1 to length(cWrd) do
               begin
                  D2[0]:=DB[0];
                  inc(D2);inc(DB);
               end;
         end;
      end;
   end;

   procedure PlaceSimpleOrd(Tbl:byte;DB:PChar;var D2:PChar);
   var
      N           : integer;
   begin
      with RI^ do
      begin
         if PW=WO then
            inc(Tbl,4);
         case Tbl of
            0: NDX:=ord(T0WALoc[ord(DB[0])]);
            1: NDX:=ord(T1WALoc[ord(DB[0])]);
            2: NDX:=ord(T2WALoc[ord(DB[0])]);
            3: NDX:=ord(T3WALoc[ord(DB[0])]);

            4: NDX:=ord(T0WOLoc[ord(DB[0])]);
            5: NDX:=ord(T1WOLoc[ord(DB[0])]);
            6: NDX:=ord(T2WOLoc[ord(DB[0])]);
            7: NDX:=ord(T3WOLoc[ord(DB[0])]);
         end; {case}
         if (NDX<1) or (NDX>WordMax) then
            begin
               FatalLogic('Trap 6894');
               EXIT;
            end;

         D2[0]:=' ';
         inc(D2);
         with PW^[NDX] do
         begin
            DB:=@cWrd;
            inc(DB);
            for N:=1 to length(cWrd) do
               begin
                  D2[0]:=DB[0];
                  inc(D2);inc(DB);
               end;
         end;
      end;
   end;

   procedure PlaceFormattedOrd(DB:PChar;var D2:PChar);
   var
      N           : integer;
      aByte       : byte;
      Fmt         : byte;
      Tbl         : byte;
      TrailB      : Boolean;
   begin
      with RI^ do
      begin
         aByte:=ord(DB[1]);
         TrailB:=Boolean(aByte and $01);
         aByte:=aByte shr 1;
         Fmt:=aByte and $07;
         aByte:=aByte shr 3;
         Tbl:=aByte and $03;
         if PW=WO then
            inc(Tbl,4);
         case Tbl of
            0: NDX:=ord(T0WALoc[ord(DB[0])]);
            1: NDX:=ord(T1WALoc[ord(DB[0])]);
            2: NDX:=ord(T2WALoc[ord(DB[0])]);
            3: NDX:=ord(T3WALoc[ord(DB[0])]);

            4: NDX:=ord(T0WOLoc[ord(DB[0])]);
            5: NDX:=ord(T1WOLoc[ord(DB[0])]);
            6: NDX:=ord(T2WOLoc[ord(DB[0])]);
            7: NDX:=ord(T3WOLoc[ord(DB[0])]);
         end; {case}
         if (NDX<1) or (NDX>WordMax) then
            begin
               FatalLogic('Trap 7794');
               EXIT;
            end;
         case Fmt of
            $00:
               begin
               end;
            $01:
               begin
                  D2[0]:=' ';
                  inc(D2);
               end;
            $02:
               begin
                  D2[0]:='-';
                  inc(D2);
               end;
            $03:
               begin
                  D2[0]:=',';
                  D2[1]:=' ';
                  inc(D2,2);
               end;
            $04:
               begin
                  D2[0]:='.';
                  D2[1]:=' ';
                  inc(D2,2);
               end;
            $05:
               begin
                  D2[0]:=' ';
                  D2[1]:='(';
                  inc(D2,2);
               end;
            $06:
               begin
                  D2[0]:=')';
                  D2[1]:=' ';
                  inc(D2,2);
               end;
            $07:
               begin
                  D2[0]:=')';
                  D2[1]:=',';
                  D2[2]:=' ';
                  inc(D2,3);
               end;
         end; {case}
         with PW^[NDX] do
         begin
            DB:=@cWrd;
            inc(DB);
            for N:=1 to length(cWrd) do
               begin
                  D2[0]:=DB[0];
                  inc(D2);inc(DB);
               end;
         end;
         if TrailB then
            begin
               D2[0]:=' ';
               inc(D2);
            end;
      end;
   end;

begin {UnPackWord}
   if (PC=nil) or (PC[0]=#0) then
      begin
         FatalLogic('Trap 2187');
         EXIT;
      end;

   if RI^.PW=nil then
      begin
         FatalLogic('Trap 4679');
         EXIT;
      end;

   if PC[0]<>fe254 then
      begin
         FatalLogic('Trap 2188');
         EXIT;
      end;
   SLen:=StrLen(PC);
   D1:=PC;
   D2:=PC2;

   case SLen of
      1:
         begin
            D2[0]:='?';
            D2[1]:=#0;
            EXIT;
         end;
      2:                    { Note: all calling procs control D1. Procs }
         if D1[1]=TAB then  { called control D2 (a var) }
         else
            if D1[1] in T146Set then
               begin
                  PlaceFirstOrd(0,D1+1,D2);
                  if RI^.Abort666<>0 then EXIT;
                  D2[0]:=#0;
                  EXIT;
               end
            else
               begin
                  FatalLogic('Trap 2189');
                  EXIT;
               end;
      3:
         if D1[1]=TAB then
         else
            if D1[1] in T146Set then
               begin
                  PlaceFirstOrd(0,D1+1,D2);
                  if RI^.Abort666<>0 then EXIT;
                  if D1[2] in ASCIISet then
                     begin
                        D2[0]:=D1[2];
                        inc(D2);
                     end
                  else
                     PlaceSimpleOrd(0,D1+2,D2);
                  if RI^.Abort666<>0 then EXIT;
                  D2[0]:=#0;
                  EXIT;
               end;
   end; {case}
   inc(D1);
   if D1[0]=TAB then
      begin
         RunOutP(D1+1,D2); {var var}
         D2[0]:=#0;
         EXIT;
      end;
   {---Now all SLen's are greater than 3---}
   if D1[0] in T146Set then
      if D1[1] in T146Set then
      else
         begin {1st a bird}
            PlaceFirstOrd(0,D1,D2);
            if RI^.Abort666<>0 then EXIT;
            inc(D1);
         end
   else
      if D1[0] in [#1..#4] then
         begin
            PlaceFirstOrd(ord(D1[0])-1,D1+1,D2);
            if RI^.Abort666<>0 then EXIT;
            inc(D1,2);
         end;
   while D1[0]<>#0 do
   begin
      if D1[0]=fc252 then
         begin
            inc(D1);
            SfxUnPack(D1,D2,N,N2);
            inc(D1,N);
            inc(D2,N2);
         end
      else
         if D1[0] in T146Set then
            if D1[1] in T146Set then {dog}
               begin
                  PlaceFormattedOrd(D1,D2);
                  if RI^.Abort666<>0 then EXIT;
                  inc(D1,2);
               end
            else
               if D1[1] in [#01..#04] then {bird; next is cat}
                  begin
                     PlaceSimpleOrd(0,D1,D2);
                     if RI^.Abort666<>0 then EXIT;
                     inc(D1);
                  end
               else
                  begin {bird followed by unknown}
                     PlaceSimpleOrd(0,D1,D2);
                     if RI^.Abort666<>0 then EXIT;
                     inc(D1);
                  end
         else
            if D1[0] in [#01..#04] then
               begin
                  PlaceSimpleOrd(ord(D1[0])-1,D1+1,D2);
                  if RI^.Abort666<>0 then EXIT;
                  inc(D1,2);
               end
            else
               if D1[0] in ASCIISet then
                  while D1[0] in ASCIISet do
                     begin
                        D2[0]:=D1[0];
                        inc(D1);inc(D2);
                     end
               else
                  begin
                     FatalLogic('Trap 2167');
                     EXIT;
                  end;
   end;
   D2[0]:=#0; {necessary, since Opening may have "zero-len" input (not handled) }
end; {UnPackWord}

procedure UnPackDate(PC,PC2:PChar);
var
   N              : integer;
   SLen           : word;
   Year,Mon,Day   : integer;
   D1,D2          : PChar;
   locStr         : Str31;
   wkStr          : Str31;
begin {UnPackDate}
   if PC=nil then
      begin
         FatalLogic('Trap 2788');
         EXIT;
      end;
   if PC[0]<>fe254 then
      begin
         FatalLogic('Trap 2789');
         EXIT;
      end;
   D1:=PC+1;
   D2:=PC2;
   if D1[0]=TAB then
      begin
         inc(D1);
         RunOutP(D1,D2);
         EXIT;
      end;
   SLen:=StrLen(D1);
   case SLen of
      0:
         begin
            StrCopy(D2,'????.??.??'+#0);
            EXIT;
         end;
      1: begin
           Year:=ord(RI^.TxfFm246[ord(D1[0])]);
           Year:=Year-123+2000;
           locStr:=ValToStr(Year,4);
           wkStr:='.??.??';
           ASMCat(locStr,wkStr);
           RunOut(locStr,D2);
           EXIT;
         end;
      2: begin
            Move(D1^,Year,sizeOf(integer));
            Day:=Year and $001f;
            Year:=Year shr 5;
            Mon:=Year and $000f;
            Year:=(Year shr 4)+1937;
            locStr:=ValToStr(Year,4);
            ASMCatC(locStr,'.');
            wkStr:=ValToStr(Mon,2);
            ASMCat(locStr,wkStr);
            ASMCatC(locStr,'.');
            wkStr:=ValToStr(Day,2);
            ASMCat(locStr,wkStr);
            RunOut(locStr,D2);
            EXIT;
         end;
      3:
         begin
            Move(D1^,Year,sizeOf(integer));
            Mon:=ord(D1[2]);
            locStr:=ValToStr(Year,4);
            ASMCatC(locStr,'.');
            wkStr:=ValToStr(Mon,2);
            ASMCat(locStr,wkStr);
            wkStr:='.??';
            ASMCat(locStr,wkStr);
            RunOut(locStr,D2);
            EXIT;
         end;
      4:
         begin
            RunOutP(D1,D2);
            inc(D1,4);
            locStr:='.??.??';
            RunOut(locStr,D2);
            EXIT;
         end;
      5:
         begin
            StrMove(D2,D1,4);
            inc(D2,4);
            locStr:='.00.00';
            RunOut(locStr,D2);
            EXIT;
         end;
      8:
         begin
            StrMove(D2,D1,4);
            inc(D1,4);inc(D2,4);
            D2[0]:='.';inc(D2);
            StrMove(D2,D1,2);
            inc(D1,2);inc(D2,2);
            D2[0]:='.';inc(D2);
            StrMove(D2,D1,2);
            D2[2]:=#0;
            EXIT;
         end;
      else
         FatalLogic('Trap 3349');
   end; {case}
end; {UnPackDate}

procedure UnPackRound(PC,PC2:PChar);
var
   N              : integer;
   SLen           : word;
   D1,D2          : PChar;
   locStr         : Str31;
   wStr           : Str31;
   Fmt            : byte;
   aByte          : byte;
begin {UnPackRound}
   if PC=nil then
      begin
         FatalLogic('Trap U788');
         EXIT;
      end;
   if PC[0]<>fe254 then
      begin
         FatalLogic('Trap U789');
         EXIT;
      end;
   D1:=PC+1;
   D2:=PC2;
   if D1[0]=TAB then
      begin
         inc(D1);
         RunOutP(D1,D2);
         EXIT;
      end
   else
      if D1[0] in ASCIISet then
         begin
            RunOutP(D1,D2);
            EXIT;
         end;
   SLen:=StrLen(D1);
   case SLen of
      0:
         begin
            D2[0]:='?';
            D2[1]:=#0;
         end;
      1: begin
            Fmt:=(ord(D1[0]) and $30) shr 4;
            aByte:=(ord(D1[0]) and $0f);
            case Fmt of
              $00:
                 begin
                    FatalLogic('Trap 3641'); {free for use for another format}
                    EXIT;
                 end;
              $01:
                 begin
                    locStr:=ValToStr(aByte+1,2);
                    D2[0]:=locStr[1];
                    D2[1]:=locStr[2];
                    D2[2]:=#0;
                 end;
              $02:
                 begin
                    locStr:=ValToStr(aByte+1,2);
                    D2[0]:=locStr[1];
                    D2[1]:='.';
                    D2[2]:=locStr[2];
                    D2[3]:=#0;
                 end;
              $03:
                 begin
                    Str(aByte+1,locStr);
                    locStr:=locStr+'.0';
                    RunOut(locStr,D2);
                 end;
            end;
         end;
      2: begin
            case D1[0] of
               #3:
                  begin
                     aByte:=ord(RI^.TxfFm150[ord(D1[1])]);
                     Str(aByte,locStr);
                     locStr:=locStr+'.0';
                     RunOut(locStr,D2);
                  end;
               #4:
                  begin
                     aByte:=ord(RI^.TxfFm150[ord(D1[1])]);
                     Str(aByte,locStr);
                     RunOut(locStr,D2);
                  end;
               else
                  begin
                     aByte:=ord(RI^.TxfFm150[ord(D1[0])]);
                     Str(aByte,locStr);
                     aByte:=ord(RI^.TxfFm150[ord(D1[1])]);
                     Str(aByte,wStr);
                     ASMCatC(locStr,'.');
                     ASMCat(locStr,wStr);
                     RunOut(locStr,D2);
                  end;
            end; {case}
         end;
      3: FatalLogic('Trap 4528'); {prog. logic}
   end; {case}
end; {UnPackRound}

procedure UnPackECO(PC,PC2:PChar);
var
   N              : integer;
   NDX            : integer;
   SLen           : word;
   D1,D2          : PChar;
   DX             : PChar;
   EDisp          : PChar;
   EArg           : PChar;
   EArgBuf        : array [0..6] of char;
   locStr         : Str31;
   wkStr          : Str31;
begin {UnPackECO}
   if PC=nil then
      begin
         FatalLogic('Trap 3188');
         EXIT;
      end;
   if PC[0]<>fe254 then
      begin
         FatalLogic('Trap 3189');
         EXIT;
      end;
   PC2[0]:=#0; {in case input is "zero-len"}
   D1:=PC+1;
   D2:=PC2;
   if D1[0]=TAB then
      begin
         inc(D1);
         RunOutP(D1,D2);
         EXIT;
      end;
   SLen:=StrLen(D1);
   case SLen of
      1:
         with RI^ do
         begin
            EArg:=EArgBuf;
            NDX:=(ord(TxfFm246[ord(D1[0])])-1)*3;
            DX:=ECOStr+NDX;
            Move(DX^,EArgBuf,3);
            EArg[3]:=#0;
            RunOutP(EArg,D2);
         end;
      2:
         begin
            D2[0]:=chr(ord(D1[0])+64);inc(D2);
            wkStr:=ValToStr(ord(ri^.TxfFm246[ord(D1[1])])-1,2);
            RunOut(wkStr,D2);
         end;
      3:
         with RI^ do
         begin
            if D1[0]<=#5 then
               D2[0]:=chr(ord(D1[0])+64)
            else
               D2[0]:=chr(ord(D1[0])+16);
            inc(D2);
            wkStr:=ValToStr(ord(ri^.TxfFm246[ord(D1[1])])-1,2);
            RunOut(wkStr,D2);
            D2[0]:='/';inc(D2);
            wkStr:=ValToStr(ord(ri^.TxfFm246[ord(D1[2])])-1,2);
            if D1[0]<=#5 then
            else
               wkStr[2]:=#0;
            RunOut(wkStr,D2);
         end;
   end; {case}
end; {UnPackECO}

procedure UnPackELO(PC,PC2:PChar);
var
   N,N2     : integer;
   ELO      : integer;
   SLen     : word;
   D1       : PChar;
   D2       : PChar;
   locStr   : Str31;
begin
   if PC=nil then
      begin
         FatalLogic('Trap 3877');
         EXIT;
      end;
   D1:=PC;
   D2:=PC2;
   if D1[0]<>fe254 then
      begin
         FatalLogic('Trap 3878');
         EXIT;
      end;
   inc(D1);
   if D1[0]=TAB then
      begin
         RunOutP(D1+1,D2);
         EXIT;
      end;
   SLen:=StrLen(D1);
   case SLen of
      0:
         begin
            D2[0]:=#0; { null, not [ECO "?"] }
         end;
      1:
         begin
            ELO:=ord(RI^.TxfFm246[ord(D1[0])])+2400;
            locStr:=ValToStr(ELO,4);
            RunOut(locStr,D2);
         end;
      2:
         begin
            N:=ord(RI^.TxfFm246[ord(D1[0])])-1; {5/98 -1 added}
            N2:=ord(RI^.TxfFm246[ord(D1[1])])-1; {5/98 -1 added}
            ELO:=N*100+N2;
            locStr:=ValToStr(ELO,4);
            RunOut(locStr,D2);
         end;
      else
         FatalLogic('Trap 4468');
   end; {case}
end; {UnPackELO}

procedure UnPackResult(PC,PC2:PChar);
var
   SLen     : word;
   D1       : PChar;
   D2       : PChar;
   locStr   : Str31;
begin
   if PC=nil then
      begin
         FatalLogic('Trap 4877');
         EXIT;
      end;
   D1:=PC;
   D2:=PC2;
   if D1[0]<>fe254 then
      begin
         FatalLogic('Trap 4878');
         EXIT;
      end;
   inc(D1);
   if D1[0]=#0 then
      begin
         D2[0]:='?';
         D2[1]:=#0;
         EXIT;
      end
   else
      if D1[0]=TAB then
         begin
            RunOutP(D1+1,D2);
            EXIT;
         end;
   if StrLen(D1)<>1 then
      begin
         FatalLogic('Trap 8121');
         EXIT;
      end;
   case D1[0] of
      #1: locStr:='1-0';
      #2: locStr:='1/2-1/2';
      #3: locStr:='0-1';
      #4: locStr:='*';
      else
         begin
            FatalLogic('Trap 8122');
            EXIT;
         end;
   end; {case}
   RunOut(locStr,D2);
end; {UnPackResult}

procedure AddMoveNumbers(Verbose:Boolean;PC,PC2,PRslt:PChar);
var
   N,N2     : integer;
   D1,D2    : PChar;
   locStr   : Str31;
   wStr     : Str31;
   catM     : Str9;
begin
   catM:='. ';
   N:=0;
   D1:=PC;
   D2:=PC2;
   while D1[0]<>#0 do
      begin
         inc(N);
         Str(N,locStr);
         if Verbose then
            ASMCat(locStr,catM)
         else
            ASMCatC(locStr,'.');
         RunOut(locStr,D2);
         for N2:=1 to 2 do
            begin
               while not (D1[0] in [#0,' ']) do
                  begin
                     D2[0]:=D1[0];
                     inc(D2);inc(D1);
                  end;
               D2[0]:=' ';inc(D2);
               if D1[0]=#0 then
                  begin
                     D2[0]:=#0;
                     Break;
                  end
               else
                  inc(D1); {will not be #0 here since follows space}
            end;
      end;
   StrCat(D2,PRslt);
end;

procedure BreakLines(PC,PC2:PChar);
const
   CARLNF : PChar = CAR+LNF;
   SL             = 75;
var
   SLen     : word;
   D1,D2,DX : PChar;
begin
   D1:=PC;
   D2:=PC2;
   D2[0]:=#0;

   REPEAT
      SLen:=StrLen(D1);
      if SLen<=SL then
         begin
            StrCat(D2,D1);
            EXIT;
         end;
      DX:=D1+SL; {76th char}
      while DX[0]<>' ' do dec(DX);
      DX[0]:=#0;
      StrCat(D2,D1);
      StrCat(D2,CARLNF);
      D2:=StrScan(D2,#0);
      D1:=DX+1;
   UNTIL TRUE=False;
end;

function HeaderBuilding(var D1:PChar;PC2,PRslt:PChar):Boolean;
var
   N           : integer;
   DX          : PChar;
   locStr      : Str255;
   wStr        : Str255;
   appr        : Str9;
   PC          : PChar;
   PCStor      : array [0..511] of char; {dbl size in case of unexpected, long tags}
   svChr       : char;
   hasMore     : Boolean;

   function ScanNext(var D1:PChar;Must:Boolean;SC:char):Boolean;
   var
      DX    : PChar;
   begin
      DX:=StrScan(D1,SC);
      if DX=nil then
         if Must then
            begin
               FatalLogic('Trap 7431');
               ScanNext:=false;
            end
         else
            ScanNext:=false
      else
         begin
            D1:=DX;
            ScanNext:=True;
         end;
   end;

   procedure RunOutX(DB,D2:PChar); {does not advance externals}
   begin
      while DB[0]<>#0 do
         begin
            D2[0]:=DB[0];
            inc(D2);inc(DB);
         end;
      D2[0]:=#0;
   end;

begin
   HeaderBuilding:=false;
   appr:='"]'+CAR+LNF;
   PC2[0]:=#0;
   PC:=PCStor;
   WITH RI^ DO
   for N:=1 to 18 do
      begin
         DX:=D1+1;
         if N<7 then
            if ScanNext(DX,True,fe254) then
               hasMore:=True
            else
               EXIT
         else
            if ScanNext(DX,false,fe254) then
               hasMore:=True
            else
               if ScanNext(DX,True,fd253) then
                  hasMore:=false
               else
                  EXIT;
         svChr:=DX[0];
         DX[0]:=#0;
         case N of
            1: begin
                  locStr:='[Event "';
                  PW:=WA;
                  UnPackWord(D1,PC);
               end;
            2: begin
                  PW:=WA;
                  locStr:='[Site "';
                  UnPackWord(D1,PC);
               end;
            3: begin
                  locStr:='[Date "';
                  UnPackDate(D1,PC);
               end;
            4: begin
                  locStr:='[Round "';
                  UnPackRound(D1,PC);
               end;
            5: begin
                  locStr:='[White "';
                  UnPackName(D1,PC);
               end;
            6: begin
                  locStr:='[Black "';
                  UnPackName(D1,PC);
               end;
            7: begin
                  locStr:='[Result "';
                  UnPackResult(D1,PC);
                  StrCopy(PRslt,PC);
               end;
            8: begin
                  locStr:='[ECO "';
                  UnPackECO(D1,PC);
                  if PC[0]=#0 then
                     locStr:='';
               end;
            9: begin
                  locStr:='[WhiteElo "';
                  UnPackELO(D1,PC);
                  if PC[0]=#0 then
                     locStr:='';
               end;
           10: begin
                  locStr:='[BlackElo "';
                  UnPackELO(D1,PC);
                  if PC[0]=#0 then
                     locStr:='';
               end;
           11: begin
                  locStr:='[Opening "';
                  PW:=WO;
                  UnPackWord(D1,PC);
                  if PC[0]=#0 then
                     locStr:='';
               end;
           12: begin
                  locStr:='[PlyCount "';
                  if D1[1]<>#0 then   {eg, zero-len field}
                     RunOutX(D1+1,PC) {+1 since working directly from input}
                  else
                     locStr:='';
               end;
           13: begin
                  locStr:='[FEN "';
                  if D1[1]<>#0 then
                     RunOutX(D1+1,PC)
                  else
                     locStr:='';
               end;
           14: begin
                  locStr:='[WhiteTitle "';
                  if D1[1]<>#0 then
                     RunOutX(D1+1,PC)
                  else
                     locStr:='';
               end;
           15: begin
                  locStr:='[BlackTitle "';
                  if D1[1]<>#0 then
                     RunOutX(D1+1,PC)
                  else
                     locStr:='';
               end;
           16: begin
                  locStr:='[WhiteCountry "';
                  if D1[1]<>#0 then
                     RunOutX(D1+1,PC)
                  else
                     locStr:='';
               end;
           17: begin
                  locStr:='[BlackCountry "';
                  if D1[1]<>#0 then
                     RunOutX(D1+1,PC)
                  else
                     locStr:='';
               end;
           18: begin
                  locStr:='[Annotator "';
                  if D1[1]<>#0 then
                     RunOutX(D1+1,PC)
                  else
                     locStr:='';
               end;
         end; {case}
         if Abort666<>0 then EXIT;
         DX[0]:=svChr;
         if locStr<>'' then
            begin
               wStr:=StrPas(PC);
               ASMCat(locStr,wStr);
               ASMCat(locStr,appr);
               StrPCopy(PC,locStr);
               StrCat(PC2,PC);
            end;
         D1:=DX;
         if not hasMore then
            Break;
      end; {for N:=1 to 18 do}
   HeaderBuilding:=True;
end;

procedure UnPackPGNGame(Flags:integer;PC,PC2:PChar);
var
   FlIn,FlOut  : text;
   D1          : PChar;
   ORslt       : array [0..31] of char;
   PRslt       : PChar;
   PCEnd       : PChar;
   Version     : byte;
   MarkDel     : byte;
   svChr       : char;
   Verbose     : Boolean;

begin {UnPackPGNGame}
   with RI^ do
   begin

   if work2PC=nil then {used below to unpack notation}
      GetMem(work2PC,PCharStrLen);

   PRslt:=ORslt;
   MarkDel:=0;
   PCEnd:=StrEnd(PC)+1; {used as work area}

   D1:=PC;
   PC2[0]:=#0;

   if D1[0]<>ff255 then
      begin
         FatalLogic('Trap U632');
         EXIT;
      end;

   D1[1]:=TxfFm246[ord(D1[1])];
   Version:=ord(D1[1]) shr 2;
   if Version<>cVersion then
      begin
         FatalLogic('Trap U633');
         EXIT;
      end;
   
   inc(D1,1);

   svChr:=PC[1]; {restored at bottom}
   PC[1]:=fe254; {eg, D1[0], Event given artificial marker (over Version/Mark) }

   if not HeaderBuilding(D1,PC2,PRslt) then
      EXIT;

   StrCat(PC2,CAR+LNF); {blank line between headers & nota}

   if D1[0]<>fd253 then
      begin
         FatalLogic('Trap 2805'); {somebody edited the packed file}
         EXIT;
      end;

   UnPackNotation(D1,work2PC);

   if (Flags and $0010)=FMT_Verbose then
      Verbose:=True
   else
      Verbose:=false;

   if (D1[1]=fc252) or (StrScan(work2PC,'.')=nil) then
      begin
         AddMoveNumbers(Verbose,work2PC,PCEnd,PRslt);
         BreakLines(PCEnd,work2PC);
         StrCat(PC2,work2PC);
      end
   else
      begin
         if Verbose then
         else
            while SubP('.','. ',work2PC,nil) do;
         BreakLines(work2PC,PCEnd);
         StrCat(PC2,PCEnd);
      end;
   PC[1]:=svChr; {pkd game put back the way it came in}
   end; {with RI^ do}
end; {UnPackPGNGame}

procedure RetrieveField(FID:integer;PC,PC2:PChar);
var
   D1          : PChar;
   DX          : PChar;
   locBuf      : array [0..1023] of char;
   locPC       : PChar;
   svChr       : char;

   procedure RunOutX(DB,D2:PChar); {does not advance externals}
   begin
      while DB[0]<>#0 do
         begin
            D2[0]:=DB[0];
            inc(D2);inc(DB);
         end;
      D2[0]:=#0;
   end;

begin
   PC2[0]:=#0;
   locPC:=locBuf;
   D1:=StrScan(PC,fd253);
   if D1=nil then
      begin
         FatalLogic('Trap 2016');
         EXIT;
      end;
   if FID=99 then
      begin
         UnPackNotation(D1,PC2);
         EXIT;
      end;

   svChr:=D1[0];
   D1[0]:=#0;
   StrLCopy(locPC,PC,1023);
   D1[0]:=svChr;
   locPC[1]:=fe254;
   D1:=StrNScan(locPC,fe254,FID);
   if D1=nil then EXIT;
   DX:=StrScan(D1+1,fe254);
   if DX<>nil then
      DX[0]:=#0;
   
   with RI^ do
   case FID of
      1: begin {Event}
            PW:=WA;
            UnPackWord(D1,PC2);
         end;
      2: begin {Site}
            PW:=WA;
            UnPackWord(D1,PC2);
         end;
      3: begin {Date}
            UnPackDate(D1,PC2);
         end;
      4: begin {Round}
            UnPackRound(D1,PC2);
         end;
      5: begin {White}
            UnPackName(D1,PC2);
         end;
      6: begin {Black}
            UnPackName(D1,PC2);
         end;
      7: begin {Result}
            UnPackResult(D1,PC2);
         end;
      8: begin {ECO}
            UnPackECO(D1,PC2);
         end;
      9: begin {WhiteElo}
            UnPackELO(D1,PC2);
         end;
     10: begin {BlackElo}
            UnPackELO(D1,PC2);
         end;
     11: begin {Opening}
            PW:=WO;
            UnPackWord(D1,PC2);
         end;
     12: begin {PlyCount}
            if D1[1]<>#0 then
               RunOutX(D1+1,PC2);
         end;
     13: begin {FEN}
            if D1[1]<>#0 then
               RunOutX(D1+1,PC2);
         end;
     14: begin {WhiteTitle}
            if D1[1]<>#0 then
               RunOutX(D1+1,PC2);
         end;
     15: begin {BlackTitle}
            if D1[1]<>#0 then
               RunOutX(D1+1,PC2);
         end;
     16: begin {WhiteCountry}
            if D1[1]<>#0 then
               RunOutX(D1+1,PC2);
         end;
     17: begin {BlackCountry}
            if D1[1]<>#0 then
               RunOutX(D1+1,PC2);
         end;
     18: begin {Annotator}
            if D1[1]<>#0 then
               RunOutX(D1+1,PC2);
         end;
   end; {case}
end;

function ValidateGame(PC:PChar):Boolean;
var
   Ver         : integer;
   HdrCt       : integer;
   DX          : PChar;
   dumBoo      : Boolean;
   Hit253      : Boolean;
begin
   ValidateGame:=false;
   if (PC=nil) or (PC[0]<>ff255) then EXIT;
   Ver:=MarkDelMaint(MRK_ReturnVer,PC[1],dumboo,dumboo);
   if Ver<>cVersion then EXIT;
   HdrCt:=1; {1 for Event}
   Hit253:=false;
   DX:=PC+2;
   while DX[0]<>#0 do
      begin
         if DX[0] in XXXSet then
            case DX[0] of
               fe254: begin
                         inc(HdrCt);
                         if HdrCt>18 then
                            EXIT;
                         if Hit253 then
                            EXIT;
                      end;
               fd253: begin
                         if Hit253 then
                            EXIT;
                         Hit253:=True;
                         if DX[1]=#0 then
                            EXIT; {zero len moves}
                      end;
               fc252:;
            else
               EXIT;
            end; {case}
         inc(DX);
      end;
   if (not Hit253) or (HdrCt<7) then
      EXIT;
   ValidateGame:=True;
end;

end.
